﻿------------------------------------------------------------------------------------------
--Death Knight Runes----------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))

local BORDER = 2
local runemap = { 1, 2, 5, 6, 3, 4 }
local GetRuneCooldown = GetRuneCooldown
local GetSpecialization = GetSpecialization
local GetRuneType = GetRuneType
local UnitClass = UnitClass
local GetTime = GetTime
local IsAddOnLoaded = IsAddOnLoaded
local collectgarbage = collectgarbage
local unpack = unpack

function SN:DKRunes(frame)
	local CLASSBAR_WIDTH = SN.data.profile.classResources.width - (BORDER*2)
	local color = M.classResources.DEATHKNIGHT
	local maxRune = SN['classMaxResourceBar']["DEATHKNIGHT"]

	local runes = CreateFrame("Frame", nil, frame)
	runes:SetSize(CLASSBAR_WIDTH, SN.data.profile.classResources.height)
	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(runes)
	else
		runes:SetBackdrop({
			bgFile = M.media.blankTex, 
			edgeFile = M.media.blankTex, 
			tile = false, tileSize = 0, edgeSize = 2, 
			insets = { left = 2, right = 2, top = 2, bottom = 2 }
			})
		runes:SetBackdropColor(0.1, 0.1, 0.1, 1)
		runes:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end
	runes:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, 0)
	runes.maxRune = maxRune
	for i = 1, maxRune do
		runes[i] = CreateFrame("StatusBar", nil, runes)
		runes[i]:SetSize((SN.data.profile.classResources.width - 15) / 6, SN.data.profile.classResources.height)
		runes[i]:SetOrientation(SN.data.profile.classResources.orientation)

		runes[i].spark = runes[i]:CreateTexture(nil, "OVERLAY")
		runes[i].spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
		runes[i].spark:SetPoint("CENTER", runes[i], "RIGHT")
		runes[i].spark:SetBlendMode("ADD")
		runes[i].spark:Hide()

		local offset
		if i == 1 then
			runes[i]:SetPoint("LEFT", runes)
		else
			runes[i]:SetPoint("LEFT", runes[(i - 1)], "RIGHT", 3, 0)
		end
		runes[i]:SetStatusBarTexture(M.media.minTex)
		runes[i]:GetStatusBarTexture():SetHorizTile(false)
	end
	
	return runes
end

function SN:SetupRunes()
	if select(2, UnitClass("player")) ~= "DEATHKNIGHT" then return end
	local frame = F.classpower
	frame.runes = SN:DKRunes(frame)
	F.classpower.frame = frame.runes

	frame.runes:RegisterEvent("RUNE_TYPE_UPDATE")
	frame.runes:RegisterEvent("RUNE_POWER_UPDATE")
	frame.runes:SetScript('OnUpdate', function(self, elapsed)
		if GetSpecialization() == nil and elapsed then return end
		local runes = self:GetParent()
		if(runes) then
			for i=1, self.maxRune do
				SN:UpdateType(self, nil, i)
			end
		end
		self:SetScript('OnUpdate', nil)
	end)
	frame.runes:SetScript("OnEvent", function(self, event, ...)
		if event == "RUNE_POWER_UPDATE" then
			local rid = ...
			SN:UpdateRune(self, event, rid, true)
		elseif event == "RUNE_TYPE_UPDATE" then
			local rid = ...
			SN:UpdateType(self, event, rid, true)
		end
		--SN:EventHandler(self, event, ...)
	end)
	if (IsAddOnLoaded("ElvUI")) then
	
	end
	if not SN.data.profile.classResources.enable then
		SN:RuneDisable()
	end
end

function SN:UpdateType(self, event, rid)
	local runeColors = M.classResources.DEATHKNIGHT
	local rune = self[runemap[rid]]
	if not GetRuneType(rid) and not alt then return; end
	local colors = runeColors[GetRuneType(rid) or alt]
	--local r, g, b = colors[1], colors[2], colors[3]

	rune:SetStatusBarColor(unpack(colors))
end

function Update(self, event)
	for i=1, self.maxRune do
		SN:UpdateRune(self, event, i)
	end
end

function UpdateAllRuneTypes(self, elapsed)
	if GetSpecialization() == nil and elapsed then return end
	local runes = self:GetParent()
	if(runes) then
		for i=1, self.maxRune do
			SN:UpdateType(runes, nil, i)
		end
	end
	self:SetScript('OnUpdate', nil)
end

function SN:UpdateRune(self, event, rid)
	local rune = self[runemap[rid]]
	if(rune) then
		local start, duration, runeReady = GetRuneCooldown(rid)
		if (runeReady) then
			rune:SetMinMaxValues(0, 1)
			rune:SetValue(1)
			rune:SetAlpha(1)
			rune:SetScript("OnUpdate", nil)
			rune.spark:Hide()
		else
			rune.duration = GetTime() - start
			rune.max = duration
			rune:SetMinMaxValues(1, duration)
			rune:SetAlpha(0.45)
			rune:SetScript("OnUpdate", function(self, elapsed)
				local duration = self.duration + elapsed
				if(duration >= self.max) then
					return self:SetScript("OnUpdate", nil)
				else
--					if SN.data.profile.classResources.orientation == "VERTICAL" then
--						local offset = (duration/self.max) * self:GetHeight()
--						--self.spark:SetRotation(1.6)
--						--self.spark:SetWidth(self:GetWidth())
--						--self.spark:SetHeight(2)
--						self.spark:SetPoint("CENTER", self, "BOTTOM", 0, offset)

--					else
--						local offset = (duration/self.max) * self:GetWidth()
--						self.spark:SetHeight(self:GetHeight())
--						self.spark:SetPoint("CENTER", self, "LEFT", offset, 0)	
--					end
					self.duration = duration
					--self.spark:Show()
					return self:SetValue(duration)
				end
			end)
		end
	end
end


function SN:RuneEnable()
	local frame = F.classpower
	frame.runes:Show()
	frame.runes:RegisterEvent("RUNE_TYPE_UPDATE")
	frame.runes:RegisterEvent("RUNE_POWER_UPDATE")
end

function SN:RuneDisable()
	local frame = F.classpower
	frame.runes:UnregisterEvent("RUNE_TYPE_UPDATE")
	frame.runes:UnregisterEvent("RUNE_POWER_UPDATE")
	frame.runes:Hide()
	collectgarbage("collect")
end