﻿------------------------------------------------------------------------------------------
-- Threat Frame---------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))

function SN:SetupThreat()

	F.threat = CreateFrame("Frame", threat, UIParent)
	F.threat:SetPoint(unpack(SN.data.profile.Frames.threat))
	F.threat:SetWidth(250)
	F.threat:SetHeight(100)
	F.threat:SetClampedToScreen(true)

	F.threat:SetScript("OnEvent", function(self, event, ...)
		SN:ThreatEvents(self, event, ...)
	end)

	F.threat.value = F.threat:CreateFontString(nil, "ARTWORK")
	F.threat.value:SetFont(M.media.font, 24, "OUTLINE")
	F.threat.value:SetTextColor(0.78, 0.25, 0.25)
	F.threat.value:SetText("")
	F.threat.value:SetAllPoints(F.threat)
	F.threat.value:SetJustifyH("CENTER")
	F.threat.value:SetJustifyV("MIDDLE")
	
	--Register the events for this frame
	--f.threat:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
	--f.threat:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
	--f.threat:RegisterEvent("PLAYER_REGEN_ENABLED")
	F.threat:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "EventHandler")
	F.threat:RegisterEvent("UNIT_SPELLCAST_SENT", "EventHandler")
	
end

function SN:ThreatEvents(self, event, ...)

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if type == "SPELL_CAST_SUCCESS" then
			if sourceName == UnitName("player") then
				--Checking to see if this success was a threat spell
				for i, threat in pairs(SN.data.profile.threat.spells) do
					if spellId == i then
						if threat.class == select(2, UnitClass("player")) then		
							if threat.msg == true then								
								SN:Announcer(self, nil, spellId, sourceName, destName, true)
							end
						end
					end
				end
			end
		elseif type == "SPELL_CAST_FAILED" then
			--Checking to see if this success was a threat spell
			if (extraFlag1 == SPELL_FAILED_NOT_ON_MOUNTED) or (extraFlag1 == SPELL_FAILED_NOT_ON_SHAPESHIFT) then
				for i, spells in pairs(SN.data.profile.threat.spells) do
					if spellId == spells.id then
						if spells.msg == true then
							SN:Announcer(self, nil, spellId, sourceName, self.storeMDtar, false)
						end
					end
				end
			end
		end
	end

	if event == "UNIT_SPELLCAST_SENT" then
		--Store the target name for the misdirect/tricks of the trade since the failed event doesn't have a target arg
			local sourceName, spellId, _, destName = ...
			if sourceName == UnitName("player") then
				for i, threat in pairs(SN.data.profile.threat.spells) do
					if spellId == i.id then
						if i.msg == true then
							self.storeMDtar = destName
						end
					end
				end
			end
		end
	end
end